package dssupd;

import javax.swing.*;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/* @author Choudhury */
public class Main{
    public static String moduleNames[] = new String[200];

    public static boolean flag = false;
    public static deckTabs drawDecks;
    public static boolean impossible = false;
    public static int noOfDeck, noOfRank, noOfCrew, deckArea, singleCrewModuleSize, 
            doubleCrewModuleSize, corridor, noOfSingleCrewModule, noOfdoubleCrewModule,
            noOfStaircase, areaOfStaircase, noOfModules, deckLen, deckWidth,
            noOfOfficerModules, unplaced, placed, currentDeck, currentRank, rest,
            startX, startY, subGridBreadth, currentPart, noOfRankOrig,
            smIndex = 0, dmIndex = 0;
    public static int[] noOfPersonInEachRank = new int[20];
    public static int[] officerModuleSizes = new int[20];
    public static int[][][] decks = new int[10][80][80];
    public static int[][][] c = new int[10][80][80];
    public static module[] allModules = new module[200];
    public static fixedModule staircase, singleCrew, doubleCrew;
    public static fixedModule[] officerModules = new fixedModule[20];

    public static subGrids grid[] = new subGrids[20];

    public static rect[][] rectX = new rect[10][200];
    public static rect[][] rectY = new rect[10][200];
    public static int[] noOfRX = new int[10];
    public static int[] noOfRY = new int[10];

    public static int[][] deckVsMod = new int[10][100];
    public static int[] counts = new int[10];
    public static boolean[] placedMod = new boolean[200];
    public static int modL, modW, minLen;
    public static module tm;
    public static int extra = 0;
    public static String un[] = {"Pwc", "Sts", "Ec","", "Ms", "Cr","Of", "Gym", "Wd", "Sto","Dr","Gly", "Ps"};

 public static void main(String[] args) throws Exception
 {
    try{
        //String filename = "C:\\Users\\Choudhury\\Desktop\\dss\\dss_input.xls";
    String filename = "dss_input.xls";
    List sheetData = new ArrayList();
    FileInputStream fis = null;
    try {
        fis = new FileInputStream(filename);
        HSSFWorkbook workbook = new HSSFWorkbook(fis);
        HSSFSheet sheet = workbook.getSheetAt(0);
        
        Iterator rows = sheet.rowIterator();
        while (rows.hasNext())
        {
            HSSFRow row = (HSSFRow) rows.next();
            Iterator cells = row.cellIterator();
            List data = new ArrayList();
            while (cells.hasNext())
            {
                HSSFCell cell = (HSSFCell) cells.next();
                data.add(cell);
            }
            sheetData.add(data);
        }
    } 
    catch (IOException e)
    {
        e.printStackTrace();
        JOptionPane.showMessageDialog(null, "Input file dss_input.xls is not found");
    }
    finally
    {
        if (fis != null) fis.close();
    }
    for(int i=0; i<200; i++) placedMod[i] = false;
    for(int i=0; i<noOfDeck; i++) counts[i] = 0;
    readExcelData(sheetData);

    corridor = 3; //1.5 meter
    for(int i = 0; i<noOfDeck; i++)
        for(int j=0; j<deckWidth; j++)
            for (int k=0; k< deckLen; k++)
            {
                decks[i][j][k] = 0;
                c[i][j][k] = 0;
            }
    if(noOfStaircase == 0)
    {
        
    }
    else placeStairs();

    for(int pp = 0; pp < noOfDeck; pp++ )
    {
        noOfRX[pp] = 0;
        noOfRY[pp] = 0;
    }
    
    unplaced = noOfOfficerModules; // total officer module
    placed = 0; // current rank officer module
    currentDeck = 0; // topmost deck
    currentRank = 0; // higest rank
    currentPart = 1;
    rest = (deckWidth - staircase.width - 2*corridor)/2;
    startX = startY = 0;
    int kk = 0;
    while (unplaced > 0 && kk < 2 && kk < noOfDeck)
    {
        subGridBreadth = staircase.length; // for left/right portion
        placeAM1();
        if(unplaced > 0)currentDeck++;
        kk++;
    }
    while (unplaced > 0 && kk < noOfDeck)
    {
        placeAM2();
        if(unplaced > 0)currentDeck++;
        kk++;
    }
    //printDecks(); //debug purpose
    System.out.println("before.........................cd = " + currentDeck + " cp = " + currentPart + " cr = " + currentRank + " rest = " + rest + " dl = " + deckLen);
    System.out.println("before.........................up = " + unplaced);

    extra += unplaced;
    //crewmodule processing
    int count = 0; //no of subparts
    int L = 0;
    int w = (deckWidth - staircase.width - 2*corridor) / 2;
    int usableL;
    if(w >= singleCrew.width)
        usableL = deckLen;
    else usableL = deckLen - 2 * (staircase.length + corridor);

    L = 2 * usableL * (noOfDeck - currentDeck -1);
    count += 2*(noOfDeck - currentDeck -1);
    System.out.println("1.............>>>>>......>>>>>> L = "+L);
    if(currentPart == 1) //upper left
    {
        if(rest >= singleCrew.width)
        {
            L += rest;
            count++;
            System.out.println("2.............>>>>>......>>>>>> L = "+L);
        }
        else if(w >= singleCrew.width)
        {
            currentPart = 2;
            startX = deckLen - w;
            startY = 0;
            rest = w;
            L += w;
            L += 2*(deckLen - max(max(staircase.length, singleCrew.length)+corridor, grid[currentDeck].left));
            System.out.println("3.............>>>>>......>>>>>> L = "+L);
            count += 3;
        }
        else
        {
            currentPart = 3;
            startX = 0;
            startY = grid[currentDeck].left;
            L += 2 * (deckLen - grid[currentDeck].left - staircase.length - corridor);
            count += 2;
            rest = deckLen - grid[currentDeck].left - staircase.length - corridor ;
            subGridBreadth = 0;
            System.out.println("4.............>>>>>......>>>>>> L = "+L);
        }        
    }
    else if(currentPart == 2) //lower left
    {
        if(rest >= max(singleCrew.width, doubleCrew.width))
        {
            L += rest;
            L += 2*(deckLen - max(max(staircase.length, singleCrew.length)+corridor, grid[currentDeck].left));
            count++;
            System.out.println("5.............>>>>>......>>>>>> L = "+L);
        }
        else
        {
            currentPart = 3;
            startX = startY = 0;
            int pl = deckLen - grid[currentDeck].left;
            if(w < max(singleCrew.width, doubleCrew.width))
            {
                pl -= (staircase.width + corridor);
                startY = grid[currentDeck].left;
            }
            L += 2 * pl;
            rest = pl;
            subGridBreadth = 0;
            System.out.println("6.............>>>>>......>>>>>> L = "+L);
        }
        count += 2;
    }
    else if(currentPart == 3) //upper
    {
        if(rest >= singleCrew.length)
        {
            L += rest;
            count++;
            System.out.println("7.............>>>>>......>>>>>> L = "+L);
        }
        else
        {
            currentPart = 4;
            startY = 0;
            rest = deckLen;
            if(w < singleCrew.width)
            {
                rest -= (staircase.length + corridor);
                if(currentDeck < 2)
                {
                    startY = grid[currentDeck].left;
                    rest -= grid[currentDeck].left;
                }
                else 
                {
                    startY = (staircase.length + corridor);
                    rest -= (staircase.length + corridor);
                }
            }
            subGridBreadth = 0;
        }
        L += deckLen;
        if(w < singleCrew.width)
        {
                L-= (staircase.length + corridor);
                if(currentDeck < 2) L-= grid[currentDeck].left;
                else L-= (staircase.length + corridor);
        }
        if(currentDeck < 2) L -= grid[currentDeck].left;
        System.out.println("8.............>>>>>......>>>>>> L = "+L);
        count++;
    }
    else if(currentPart == 4) //lower
    {
        if(rest >= singleCrew.length)
        {
            L += rest;
            count++;
            System.out.println("9.............>>>>>......>>>>>> L = "+L);
        }
    }
    L -= ((count-1) * max(singleCrew.length, doubleCrew.length));
    System.out.println("10.............>>>>>......>>>>>> L = "+L);
    System.out.println("available length = " + L + " sl = " + singleCrew.length + " dl = " + doubleCrew.length + "count = " + count);

    int temp = L / noOfCrew;
    System.out.println("temp = " + temp);

    if(temp >= singleCrew.length)
    {
        noOfSingleCrewModule = noOfCrew;
        noOfdoubleCrewModule = 0;

        smIndex = noOfRank;
        officerModules[noOfRank] = singleCrew;
        noOfPersonInEachRank[noOfRank] = noOfSingleCrewModule;        
        currentRank = noOfRank;
        noOfRank++;
        moduleNames[noOfRank] = "SM";
        unplaced = noOfSingleCrewModule;
        placed = 0;
    }
    else
    {
        double ttmp =  (L - (double)singleCrew.length*noOfCrew)/((double)doubleCrew.length - 2 * singleCrew.length);
        noOfdoubleCrewModule = (int)Math.ceil(ttmp);
        noOfdoubleCrewModule = min(noOfCrew/2, noOfdoubleCrewModule);
        System.out.println("here........." + ttmp + " " + singleCrew.length + " " + noOfCrew + " " + doubleCrew.length);
        if(noOfdoubleCrewModule >= 0)
        {
            noOfSingleCrewModule = noOfCrew - 2* noOfdoubleCrewModule;
            smIndex = noOfRank;
            officerModules[noOfRank] = singleCrew;
            noOfPersonInEachRank[noOfRank++] = noOfSingleCrewModule;
            moduleNames[noOfRank] = "SM";
            dmIndex = noOfRank;
            officerModules[noOfRank] = doubleCrew;
            noOfPersonInEachRank[noOfRank++] = noOfdoubleCrewModule;
            moduleNames[noOfRank] = "DM";
            currentRank = noOfRank - 2;
            unplaced = noOfSingleCrewModule + noOfdoubleCrewModule;
            placed = 0;
        }
        else 
        {
            flag = true;
            System.out.println("It is not possible to place the crew modules.");
            impossible = true;
        }
    }
    System.out.println("....................................................s = " + noOfSingleCrewModule);
    System.out.println("....................................................d = " + noOfdoubleCrewModule);
    System.out.println(".............................cd = " + currentDeck + " cp = " + currentPart + " cr = " + currentRank + " rest = " + rest + " dl = " + deckLen);
    System.out.println("...........................up = " + unplaced);

    if(noOfSingleCrewModule*singleCrew.length + noOfdoubleCrewModule*doubleCrew.length > L) impossible = true;
    if(!impossible)
    {
        if(unplaced > 0)
        {
            placeCrewMod();
            currentDeck++;
            System.out.println("ki hoilo");
        }
        int tmw = (deckWidth - staircase.width - 2*corridor)/2;
        while( unplaced > 0 && currentDeck<noOfDeck)
        {
            startX = 0;
            if((currentDeck==0 || currentDeck==1) && tmw >= singleCrew.width)
            {
                currentPart = 1;
                startY = 0;
                rest = tmw;
                subGridBreadth = staircase.width;
            }
            else
            {
                currentPart = 3;
                if(tmw >= singleCrew.width)
                {
                    startY = 0;
                    rest = deckLen;
                }
                else
                {
                    startY = staircase.length + corridor;
                    rest = deckLen - 2*startY;
                }
                subGridBreadth = staircase.width;
            }
            placeCrewMod();
            currentDeck++;
        }
        printDecks(); //debug purpose
        if(unplaced >0) flag = true;
        //System.out.println("still unplaced " + unplaced);
     }
    else flag = true;
    //System.out.println("It is not possible to place the modules in this template");
    testCM();    

    int pn = noOfRank+1;
    for(int i =0; i<noOfModules; i++)
    {
        moduleNames[pn++] = allModules[i].sName;
    }
    unplaced = noOfModules;
    System.out.println("nomod " + unplaced);
    for(currentDeck=0; unplaced>0 && currentDeck<noOfDeck; currentDeck++)
    {
        startX = grid[currentDeck].up;
        startY = grid[currentDeck].left;

        rest = deckLen - grid[currentDeck].right-grid[currentDeck].left;
        placeCMFM();
    }
    if(unplaced > 0) flag = true;
    

    try{
     new textOutput();
    drawDecks = new deckTabs();
     }
    catch(Exception e)
    {
        JOptionPane.showMessageDialog(null, "Make sure the file dss_output.csv is not open and try again.");
    }
   if(flag)
    JOptionPane.showMessageDialog(null, "Placement is not possible for current template. Change the template and try again.");
     }
    catch(Exception e){e.printStackTrace();JOptionPane.showMessageDialog(null, "Error in processing.");}

      //printDecks();
}
public static void testCM()
{
    int t = staircase.length + corridor;
    for(int i=0; i<noOfDeck; i++)
    {
        if(grid[i].left <= t) grid[i].left = t;
        if(grid[i].right <= t) grid[i].right = t;
        
        if(grid[i].up <= corridor) grid[i].up = 0;
        if(grid[i].down <= corridor) grid[i].down = 0;
        
        startX = grid[i].up;
        startY = grid[i].left;

        System.out.println("l = " + grid[i].left +" r = "+ grid[i].right +" u = "+ grid[i].up +" d= "+ grid[i].down);
        //color(i, deckWidth - grid[i].down-grid[i].up, deckLen - grid[i].right-grid[i].left , 10);
    }        
}
public static void placeStairs()
{
    if(staircase.width % 2 == 1 )
    {
        staircase.width++;
        staircase.size = staircase.length * staircase.width;
    }
    int w1 = (deckWidth - staircase.width) / 2;
    int w2 = w1 + staircase.width;
    int x2 = deckLen - staircase.length;

    for(int k=0; k<noOfDeck; k++)
    {
        grid[k] = new subGrids(0, 0, 0, 0);
        for(int i= w1; i<w2; i++)
            for(int j=0; j<staircase.length; j++)
            {
                decks[k][i][j] = 1000;
                decks[k][i][x2+j] = 1000;
            }
    }
}
public static void placeAM1()
{
    startX = 0;
    startY = 0;
    rest = (deckWidth - staircase.width - 2*corridor) / 2;
    int w1 = rest;
    currentPart = 1;
    while(unplaced > 0 && rest >=officerModules[currentRank].width)
        findModulePlaceX(rest);
    
    if(unplaced > 0)
    {
        startX = deckWidth - w1;
        startY = 0;
        rest = w1;
        currentPart = 2;
        while(unplaced > 0 && rest >=officerModules[currentRank].width)
        {
            System.out.println("w1 = " + w1 + " %%%%%%here ");
            findModulePlaceX(rest);
        }
    }
    grid[currentDeck].left = subGridBreadth + corridor;
    grid[currentDeck].right = staircase.length + corridor;

    subGridBreadth = 0;

    startX = 0;
    startY = grid[currentDeck].left;
    int l1 = deckLen - grid[currentDeck].left;
    rest = l1;
    currentPart = 3;
    if(w1 < officerModules[currentRank].width ) rest -= (staircase.length + corridor);
    while(unplaced > 0 &&  rest >=officerModules[currentRank].length)
        findModulePlaceY(rest,0); // uppper portion

    grid[currentDeck].up= subGridBreadth + corridor;
    subGridBreadth = 0;

    if(unplaced > 0)
    {
        startY = grid[currentDeck].left; //startx variable
        rest = l1;
        currentPart = 4;
        if(w1 < officerModules[currentRank].width) rest -= (staircase.length + corridor);
        while(unplaced > 0 &&  rest >=officerModules[currentRank].length)
            findModulePlaceY(rest,1);
    }
    grid[currentDeck].down = subGridBreadth + corridor;
}
public static void placeAM2()
{
    grid[currentDeck].left = staircase.length + corridor;
    grid[currentDeck].right = staircase.length + corridor;

    System.out.println("==========================================" + grid[currentDeck].left);

    subGridBreadth = 0;

    startX = 0;
    startY = grid[currentDeck].left;
    int l1 = deckLen - grid[currentDeck].left - grid[currentDeck].right;
    rest = l1;
    int w1 = (deckWidth - staircase.width - 2*corridor) / 2;
    if(w1 >= officerModules[currentRank].width)
    {
        startY = 0;
        rest += 2*(staircase.length + corridor);
    }
    currentPart = 3;
    while(unplaced > 0 &&  rest >=officerModules[currentRank].length)
        findModulePlaceY(rest,0);

    grid[currentDeck].up= max(grid[currentDeck].up, subGridBreadth + corridor);
    subGridBreadth = 0;

    if(unplaced > 0)
    {
        startX = deckWidth - officerModules[currentRank].width;
        startY = grid[currentDeck].left;
        rest = l1;
        if(w1 >= officerModules[currentRank].width)
        {
            startY = 0;
            rest += 2*(staircase.length + corridor);
        }
        currentPart = 4;
        while(unplaced > 0 && rest >=officerModules[currentRank].length)
            findModulePlaceY(rest,1);
    }
    grid[currentDeck].down = max(grid[currentDeck].down, subGridBreadth + corridor);
}
public static void findModulePlaceX(int w1)
{
    int k = min(w1/officerModules[currentRank].width, noOfPersonInEachRank[currentRank]-placed);
    System.out.println(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> k = " + k + " " + w1 + " " + officerModules[currentRank].width );

    int tl = k*officerModules[currentRank].width;
    color(currentDeck, tl, officerModules[currentRank].length,  currentRank+1);
    rectX[currentDeck][noOfRX[currentDeck]++] = new rect(startX, startY, tl, officerModules[currentRank].length, k);
    
    if(officerModules[currentRank].length > subGridBreadth)
        subGridBreadth = officerModules[currentRank].length;

    rest = w1 - k*officerModules[currentRank].width;
    startX += k*officerModules[currentRank].width;
    placed += k;
    unplaced -= k;
    
    if(placed == noOfPersonInEachRank[currentRank])
    {
        currentRank++;
        placed = 0;
    }
}
public static void findModulePlaceY(int l1, int upDown)
{
    int k = min(l1/officerModules[currentRank].length, noOfPersonInEachRank[currentRank]-placed);
    if(upDown == 1) startX = deckWidth - officerModules[currentRank].width;
    else startX = 0;

    int tl = k*officerModules[currentRank].length;
    color(currentDeck, officerModules[currentRank].width, tl,currentRank+1);
    rectY[currentDeck][noOfRY[currentDeck]++] = new rect(startX, startY, tl, officerModules[currentRank].width, k);
    if(officerModules[currentRank].width > subGridBreadth)
        subGridBreadth = officerModules[currentRank].width;

    rest = l1 - k*officerModules[currentRank].length;
    startY += k*officerModules[currentRank].length;
    placed += k;
    unplaced -= k;
    System.out.println(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> k = " + k + " " + l1 + " " + officerModules[currentRank].width);

    if(placed == noOfPersonInEachRank[currentRank])
    {
        currentRank++;
        placed = 0;
    }
}
public static void findCMFFMPlaceY(int color)
{
    System.out.println("in findcmplc");
    color(currentDeck, modW, minLen, color);
    rectY[currentDeck][noOfRY[currentDeck]++] = new rect(startX, startY, minLen, modW, 1);
    
    rest-= minLen;
    startY += minLen;
    unplaced--;
    System.out.println("..............." + startX + " " + startY +" "+ minLen +" "+ modW);
}
public static void placeCrewMod()
{
    int w1 =(deckWidth - staircase.width - 2*corridor)/2;
    switch(currentPart)
    {
        case 1:
            while(unplaced > 0 && rest >=officerModules[currentRank].width)
                findModulePlaceX(rest);

            rest = w1;
            startX = deckWidth - w1;
            startY = 0;//grid[currentDeck].left = max(grid[currentDeck].left, subGridBreadth + corridor);
                        
        case 2:
            while(unplaced > 0 && rest >=officerModules[currentRank].width)
                findModulePlaceX(rest);

            grid[currentDeck].left = max(grid[currentDeck].left, subGridBreadth + corridor);
            grid[currentDeck].right = staircase.length + corridor;
            
            subGridBreadth = 0;
            startX = 0;
            if(currentDeck < noOfDeck )
            {
                startY = grid[currentDeck].left;
                rest = deckLen - grid[currentDeck].left;
            }
            if(currentRank < noOfRank && w1 < officerModules[currentRank].width)
                rest -= (staircase.length+corridor);
            
        case 3:            
            while(unplaced > 0 &&  rest >=officerModules[currentRank].length)
                findModulePlaceY(rest,0); // uppper portion

            if(currentDeck < noOfDeck )
                grid[currentDeck].up= max(grid[currentDeck].up, subGridBreadth + corridor);

            subGridBreadth = 0;
            if(currentDeck < noOfDeck && currentDeck < 2 && currentRank < noOfRank)
            {
                startY = grid[currentDeck].left;
                rest = deckLen - startY;
                
                if(w1 < officerModules[currentRank].width)
                    rest -= (staircase.length + corridor);
            }
            else if(currentDeck < noOfDeck && currentRank < noOfRank)
            {
                startY = 0;
                rest = deckLen;

                if(w1 < officerModules[currentRank].width)
                {
                    startY = staircase.length + corridor;
                    rest -= 2*(staircase.length + corridor);
                }
            }
            if(currentRank < noOfRank)
                startX = deckWidth - officerModules[currentRank].width;
            
        case 4:
            while(unplaced > 0 &&  rest >=officerModules[currentRank].length)
                findModulePlaceY(rest,1);
            if(currentDeck < noOfDeck ) 
                grid[currentDeck].down =  max(grid[currentDeck].down, subGridBreadth + corridor);
                subGridBreadth = 0;
    }
}
public static void placeCMFM()
{
    System.out.println("in placeCMFM " + unplaced + " " + " "+currentDeck+ " " +counts[currentDeck]);
    int kk = 0;
    boolean yes = false;

    while(unplaced > 0 && kk<counts[currentDeck])
    {
        if(placedMod[deckVsMod[currentDeck][kk]])
        {
            kk++;
            continue;
        }
        tm = allModules[deckVsMod[currentDeck][kk]];
        minLen = 10000;
        yes = decideDim();
        if(yes) 
        {
            allModules[deckVsMod[currentDeck][kk]].selLen = minLen;
            allModules[deckVsMod[currentDeck][kk]].selWid = modW;
            int cl = deckVsMod[currentDeck][kk]+ noOfRank+1;
            placedMod[deckVsMod[currentDeck][kk]] = true;
            findCMFFMPlaceY(cl);
        }
        kk++;
    }
}
public static boolean decideDim()
{
    System.out.println("in dec");
    int p, q, x, y;
    boolean tag = true;
    for(int i=0; i<tm.clw; i++)
    {
        p = startX;
        q = startY;

        x = tm.width[i] + corridor;
        if(startX+x > deckWidth+corridor) continue;
        else if(startX+x == deckWidth+corridor) x-= corridor;

        y = tm.len[i] +corridor;
        if(startY +y > deckLen-staircase.length) continue;

        System.out.println("in decision " + p + " " + q + " " + x + " " + y);
        if(isEmpty(currentDeck, p, q, x, y))
        {
            System.out.println(" yes");
            tag = false;
            if(tm.len[i] < minLen)
            {
                minLen = tm.len[i];
                modW = tm.width[i];
            }
        }       
    }
    if(tag) return false;
    return true;
}
public static void color(int d, int x2, int y2, int c)
{
    try{
    System.out.println("**************************in color = " + c + " deck = " + currentDeck + " startX = "+ startX + " startY = " + startY + " x2 = " + x2 + " y2 = " + y2);
    for(int i=startX; i<startX + x2; i++)
        for(int j=startY; j<startY + y2; j++)
        {
            if( decks[d][i][j] != 0)
                flag = true;
            decks[d][i][j] = c;
        }
    }
    catch(Exception e){ flag = true;
    }
}
public static boolean isEmpty(int d, int p, int q, int x, int y)
{
    int i , j;
    //try{
    System.out.println("BBBBBBBBBBBBBBBB  " + d);
    boolean t = true;
    for(i=p; i<p+x; i++)
        for(j=q; j<q+x; j++)
        {
            if(i>=deckWidth || j >=deckLen) return false;
            if(decks[d][i][j] != 0) {t = false; break; }
        }
        
    //}catch(Exception e)   {       // System.out.println(i + " " + j);    }
    return t;
}
private static void readExcelData(List sheetData) {
    
    String t1,t2;
    HSSFCell cell;
    List list;
    module tempMod;
    int i = 0, j, k, modSize;
    noOfModules = 0;
    
    //No. of deck
    list = (List) sheetData.get(i++);
    cell = (HSSFCell) list.get(1);
    noOfDeck = (int)Float.parseFloat(cell.toString().trim());
    System.out.println("noOfDeck = " + noOfDeck);
    
    //Deck area
    list = (List) sheetData.get(i++);
    cell = (HSSFCell) list.get(1);
    deckArea = (int)Float.parseFloat(cell.toString().trim());
    cell = (HSSFCell) list.get(2);
    deckLen = 2* (int)Float.parseFloat(cell.toString().trim());
    cell = (HSSFCell) list.get(3);
    deckWidth = 2*(int)Float.parseFloat(cell.toString().trim());
    System.out.println("deckArea = " + deckArea + deckLen + deckWidth);

    //No. of rank
    list = (List) sheetData.get(i++);
    cell = (HSSFCell) list.get(1);
    noOfRank = (int)Float.parseFloat(cell.toString().trim());
    System.out.println("noOfRank = " + noOfRank);
    
    //No. of personnel in each rank (1 -> 2 -> ...)
    noOfOfficerModules = 0;
    moduleNames[0] = "ST";

    list = (List) sheetData.get(i++);
    for (j = 1; j < list.size(); j++)
    {
        cell = (HSSFCell) list.get(j);
        noOfPersonInEachRank[j-1] = (int)Float.parseFloat(cell.toString().trim());
        moduleNames[j] = "AM Rank " + j;
        System.out.print(" np = " + noOfPersonInEachRank[j-1]);
        noOfOfficerModules += noOfPersonInEachRank[j-1];
    }
    System.out.println("noofofficermodule = " + noOfOfficerModules);
    
    //No. of crew
    list = (List) sheetData.get(i++);
    cell = (HSSFCell) list.get(1);
    noOfCrew = (int)Float.parseFloat(cell.toString().trim());
    System.out.println("noOfCrew = " + noOfCrew);

    
    //Single crew module size
    list = (List) sheetData.get(i++);
    cell = (HSSFCell) list.get(1);
    singleCrewModuleSize = (int)Float.parseFloat(cell.toString().trim());
    System.out.println("singleCrewModuleSize = " + singleCrewModuleSize);
    singleCrew = new fixedModule(singleCrewModuleSize);
    
    //Double crew module size
    list = (List) sheetData.get(i++);
    cell = (HSSFCell) list.get(1);
    doubleCrewModuleSize = (int)Float.parseFloat(cell.toString());
    System.out.println("doubleCrewModuleSize = " + doubleCrewModuleSize);
    doubleCrew = new fixedModule(doubleCrewModuleSize);

    //Officer module size
    list = (List) sheetData.get(i++);
    for (j = 1; j < list.size(); j++)
    {
        cell = (HSSFCell) list.get(j);
        officerModuleSizes[j-1] = (int)Float.parseFloat(cell.toString().trim());
        System.out.print(" om = " + officerModuleSizes[j-1]);
        officerModules[j-1] = new fixedModule(officerModuleSizes[j-1]);
    }
    System.out.println("");

    //Fixed module specification
    list = (List) sheetData.get(i++);
    
    //Staircase
    //not included in module list
    list = (List) sheetData.get(i++);
    cell = (HSSFCell) list.get(1);
    noOfStaircase = (int)Float.parseFloat(cell.toString().trim());
    System.out.print(" noOfStaircase = " + noOfStaircase);
    cell = (HSSFCell) list.get(2);
    areaOfStaircase = (int)Float.parseFloat(cell.toString().trim());
    System.out.println(" areaOfStaircase = " + areaOfStaircase);
    staircase = new fixedModule(areaOfStaircase);

    //Cleaning locker, in all deck
    list = (List) sheetData.get(i++);
    cell = (HSSFCell) list.get(1);
    t1 = cell.toString();
    cell = (HSSFCell) list.get(1);
    int cln = (int)Float.parseFloat(cell.toString().trim());
    System.out.print("cln = " + cln);
    cell = (HSSFCell) list.get(2);
    int clarea = (int)Float.parseFloat(cell.toString().trim());
    System.out.print(" clarea = " + clarea);
    tempMod = new module(clarea);
    tempMod.npDecks = 1;
    tempMod.moduleName = "Cleaning Locker";
    for(k = 0; k<noOfDeck; k++)
        for(j=0; j<cln; j++)
        {
            tempMod.sName = "CL";
            tempMod.pDeck[0] = noOfDeck - k - 1; // k = deck no
            System.out.println("^^^^^^^^^^^^^^^^^.>.>.>.>.>.> " + tempMod.pDeck[0]);
            deckVsMod[tempMod.pDeck[0]][counts[tempMod.pDeck[0]]++] = noOfModules;
            allModules[noOfModules++] = tempMod;
        }

    for( ; i < sheetData.size(); i++)
    {
        list = (List) sheetData.get(i);        
        for (j = 1; j < list.size(); )
        {
            cell = (HSSFCell) list.get(0);
            t1 = cell.toString(); // module name
            cell = (HSSFCell) list.get(j++);
            t2 = cell.toString().trim(); // deck where it can be placed
            cell = (HSSFCell) list.get(j++);
            modSize = (int)Float.parseFloat(cell.toString().trim());
            System.out.println("module name = " +t1 + " deck = " + t2 + " ModSizes = " + modSize);
            if(i<=14)tempMod = new module(modSize); //fm
            else tempMod = new module(modSize); //cm
            tempMod.moduleName = t1;
            tempMod.sName = un[i-11];

            if(t2.equals("*"))
            {
                tempMod.npDecks = noOfDeck;
                for(int ts = 0; ts<noOfDeck; ts++){
                    tempMod.pDeck[ts] = ts; // ts = deck no
                    deckVsMod[ts][counts[ts]++] = noOfModules;

                System.out.print(ts +" ");}
            }
            else
            {
                tempMod.npDecks = 1;
                int nn = t2.charAt(0) - 'A';
                int nnd = noOfDeck - nn - 1;
                tempMod.pDeck[0] = nnd;
                System.out.print(t2.charAt(0) + " nn " + nn + " " + nnd);
                deckVsMod[nnd][counts[nnd]++] = noOfModules;
            }
            allModules[noOfModules++] = tempMod;
        }System.out.println("");
    }
    noOfRankOrig = noOfRank;
    System.out.println(noOfModules);
}
public static int min(int a, int b)
{
    if (b < a) return b;
    return a;
}
public static int max(int a, int b)
{
    if (b > a) return b;
    return a;
}
public static void printDecks()
{
    for(int i=0; i<noOfDeck; i++)
    {
        for(int j=0; j<deckWidth; j++)
        {
            for(int k = 0; k<deckLen; k++)
                System.out.print(decks[i][j][k]);
            System.out.println();
        }
        System.out.println(); System.out.println();
    }
}
}