/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package dssupd;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

/**
 *
 * @author Choudhury
 */
public class textOutput {

    modInfo[] allMods = new modInfo[20];
    int[] tot = new int[200];

    public textOutput() throws FileNotFoundException, IOException {
        
        FileOutputStream fout = null;
        String outfile = "dss_output.csv";
        //String outfile = "C:\\Users\\Choudhury\\Desktop\\dss\\dss_output.csv";
        fout = new FileOutputStream(outfile);

        //all modules in the decks
        int maxRank = 0;
        for(int d=0; d<Main.noOfDeck; d++)
        {
            allMods[d] = new modInfo();
            for(int j=0; j<Main.noOfRX[d]; j++)
            {
                rect tm = Main.rectX[d][j];
                int rank =  Main.decks[d][tm.stX][tm.stY]; //what is the rank/module index
                if(rank > maxRank) maxRank = rank;

                System.out.println("rank = " + rank +" " + Main.noOfRank + " " + Main.decks[d][tm.stX][tm.stY]);

                allMods[d].modsCnt[rank] += tm.noOfMod;
                allMods[d].modLen[rank] = tm.modLw;
                allMods[d].modWid[rank] = tm.totalLen/tm.noOfMod;
            }
            for(int j=0; j<Main.noOfRY[d]; j++)
            {
                rect tm = Main.rectY[d][j];
                int rank =  Main.decks[d][tm.stX][tm.stY]; //what is the rank/module index
                if(rank > maxRank) maxRank = rank;

                System.out.println("rank = " + rank +" " + Main.noOfRank + " " + Main.decks[d][tm.stX][tm.stY]);

                allMods[d].modsCnt[rank] += tm.noOfMod;
                allMods[d].modWid[rank] = tm.modLw;
                allMods[d].modLen[rank] = tm.totalLen/tm.noOfMod;
            }    
        }
        // AM names
        for(int d = 0; d< Main.noOfDeck; d++)
        {
            for (int i=1; i<=Main.noOfRankOrig; i++)
            {
                allMods[d].modName[i] = "AM Rank " + i;
                allMods[d].actualSize[i] = Main.officerModules[i-1].size;
                allMods[d].actualSize[i] = allMods[d].modLen[i]*allMods[d].modWid[i];
            }
            System.out.println("smi = " + Main.smIndex + " dmi = " + Main.dmIndex );
            //Single/Double crew modlues
            if(Main.smIndex > 0)
            {
                allMods[d].modName[Main.smIndex+1] = "Single Crew Module";
                allMods[d].modLen[Main.smIndex+1] = Main.singleCrew.length;
                allMods[d].modWid[Main.smIndex+1] = Main.singleCrew.width;
                allMods[d].modSize[Main.smIndex+1] = Main.singleCrew.length * Main.singleCrew.width;
                allMods[d].actualSize[Main.smIndex+1] = Main.singleCrewModuleSize;
            }
            if(Main.dmIndex > 0)
            {
                allMods[d].modName[Main.dmIndex+1] = "Double Crew Module";
                allMods[d].modLen[Main.dmIndex+1] = Main.doubleCrew.length;
                allMods[d].modWid[Main.dmIndex+1] = Main.doubleCrew.width;
                allMods[d].modSize[Main.dmIndex+1] = Main.doubleCrew.length * Main.doubleCrew.width;
                allMods[d].actualSize[Main.dmIndex+1] = Main.doubleCrewModuleSize;
            }
            int th = Main.noOfRank + 1;
            for (int i = 0; i<Main.noOfModules;i++)
            {
                allMods[d].modName[th+i] = Main.allModules[i].moduleName;
                allMods[d].actualSize[th+i] = Main.allModules[i].size;
                allMods[d].modSize[th+i] = Main.allModules[i].selLen * Main.allModules[i].selWid;
            }
        }
        String writeLine = "Placed Modules\n";
        fout.write(writeLine.getBytes());
        for(int d=0; d<Main.noOfDeck; d++)
        {
            char deck = (char)(Main.noOfDeck - d + 'A' - 1);
            writeLine = "\nDeck " + deck + "\n";
            fout.write(writeLine.getBytes());
            writeLine = "Module name,Number,Size(sq.m), Length(m), Width(m), Input Size(sq. m)\n";
            fout.write(writeLine.getBytes());
            
            for(int i=1;i<=maxRank; i++)
               if(allMods[d].modsCnt[i] > 0)
               {
                   float sz= (float)allMods[d].modLen[i] * allMods[d].modWid[i] / 4;
                   if(i-1 == Main.smIndex || i-1 == Main.dmIndex )
                       writeLine = allMods[d].modName[i] + "," + allMods[d].modsCnt[i]+","+ sz +
                           "," + (float)(allMods[d].modLen[i]/2) +","+ (float)(allMods[d].modWid[i]/2) +","+ allMods[d].actualSize[i] + "\n";
                   else
                   writeLine = allMods[d].modName[i] + "," + allMods[d].modsCnt[i]+","+ sz +
                           "," + (float)(allMods[d].modLen[i]/2) +","+ (float)(allMods[d].modWid[i]/2) +","+ (float)(allMods[d].actualSize[i]/4) + "\n";
                   fout.write(writeLine.getBytes());
                   System.out.println(allMods[d].modName[i] + " " + allMods[d].modsCnt[i]);
                }
            System.out.println();
        }
        
        boolean tag = false;
        for(int i=0; i<=maxRank; i++)
        {
            tot[i] = 0;
            for(int d =0; d<Main.noOfDeck; d++)
                if(allMods[d].modsCnt[i] > 0)
                    tot[i] += allMods[d].modsCnt[i];
        }
        for(int i=1; i<=Main.noOfRankOrig; i++)
            if(Main.noOfPersonInEachRank[i-1] > tot[i])tag = true;
        if(Main.noOfCrew>0 && tot[Main.smIndex+1] <=0 && tot[Main.dmIndex+1]<=0) tag = true;
        int tt = Main.noOfRank + 1;
        for (int i = 0; i<Main.noOfModules;i++)
            if(tot[tt+i] <= 0) tag = true;

        if(tag)
        {
            writeLine = "\nUnplaced Modules\n";
            fout.write(writeLine.getBytes());
            writeLine = "\nModule Name,Number,Size\n";
            fout.write(writeLine.getBytes());

            for(int i=1; i<=Main.noOfRankOrig; i++)
            {
                if(Main.noOfPersonInEachRank[i-1] > tot[i])
                {
                    writeLine = "AM Rank " + i + "," + (Main.noOfPersonInEachRank[i-1] - tot[i]) + "," +(float)(Main.officerModules[i-1].size/4)+"\n";
                    fout.write(writeLine.getBytes());
                }
            }
            if(Main.noOfCrew>0 && tot[Main.smIndex+1] <=0 && tot[Main.dmIndex+1]<=0)
            {
                writeLine = "\nCrew Module," + Main.noOfCrew + "," + Main.singleCrewModuleSize + "\n";
                fout.write(writeLine.getBytes());
            }
            for (int i = 0; i<Main.noOfModules;i++)
            {
                if(tot[tt+i] <= 0)
                {
                    writeLine = Main.allModules[i].moduleName + ",1," + (float)(Main.allModules[i].size/4)+"\n";
                    fout.write(writeLine.getBytes());
                }
            }
        }
        if (fout != null) fout.close();
    }
    public class modInfo
    {
        String[] modName = new String[200];
        int[] modsCnt = new int[200];
        int[] modLen = new int[200];
        int[] modWid = new int[200];
        int[] modSize = new int[200];
        int[] actualSize = new int[200];
        public modInfo()
        {
            for(int i=0; i<200; i++)
            {
                modName[i] = "";
                modsCnt[i] = 0;
                modLen[i] = 0;
                modWid[i] = 0;
                modSize[i] = 0;
                actualSize[i] = 0;
            }
        }
    }
}
