package dssupd;
import java.awt.*;
/* @author Choudhury*/
public class draw extends Canvas {

    Graphics2D graphics;
    int deckindex;
    boolean f[][] = new boolean[100][100];
   
    int pxl = 15;
    int stx = 10, sty = 10;
    Color color[] = {Color.WHITE, Color.BLUE, Color.GREEN, Color.ORANGE, Color.RED,
                    Color.CYAN, Color.magenta, Color.yellow, Color.DARK_GRAY,
                    Color.PINK, Color.GRAY ,Color.BLUE, Color.GREEN, Color.ORANGE, Color.RED,
                    Color.CYAN, Color.magenta, Color.yellow, Color.DARK_GRAY,
                    Color.PINK, Color.GRAY ,Color.BLUE, Color.GREEN, Color.ORANGE, Color.RED,
                    Color.CYAN, Color.magenta, Color.yellow, Color.DARK_GRAY,
                    Color.PINK, Color.GRAY};
public draw(int i)
    {
        this.deckindex = i;       
    }
public void paint(Graphics g)
{     
        graphics = (Graphics2D) g;
        super.paint(graphics);
       
        for(int j =0; j<100; j++)
            for(int k = 0; k<100; k++) f[j][k] = true;
        int xlen = Main.deckLen * pxl;
        int ylen = Main.deckWidth * pxl;

        //drawing modules
        for(int i=stx, ii=0; i<=xlen; i+=pxl, ii++)
            for(int j=sty, jj=0; j<=ylen; j+=pxl, jj++)
            {
                if(Main.decks[deckindex][jj][ii]==1000) graphics.setColor(color[0]);
                else
                graphics.setColor(color[Main.decks[deckindex][jj][ii]]);
                if(Main.decks[deckindex][jj][ii] != 0) graphics.fillRect(i, j, pxl, pxl);
            }
        //drawing grid
        graphics.setColor(Color.BLACK);
        graphics.drawRect(stx, sty, xlen, ylen);
        for(int i=stx; i<=ylen; i+=pxl)
            graphics.drawLine(stx, i, xlen+pxl-5, i);
        for(int j=sty; j<=xlen; j+=pxl)
            graphics.drawLine(j, sty, j, ylen+pxl-5);
       
        //writing mod names
        for(int i=pxl + stx, ii=0; i<=xlen; i+=pxl, ii++)
            for(int j=pxl + sty, jj=0; j<=ylen; j+=pxl, jj++)
            {
                if(Main.decks[deckindex][jj][ii]==1000 && f[deckindex][0])
                {
                    f[deckindex][0] = false;
                    try{
                        graphics.drawString(Main.moduleNames[0], i, j);
                    }catch(Exception e){}
                }
                else
                if(Main.decks[deckindex][jj][ii] != 0 && Main.decks[deckindex][jj][ii] != 1000 && f[deckindex][Main.decks[deckindex][jj][ii]])
                {
                    f[deckindex][Main.decks[deckindex][jj][ii]] = false;
                    try{
                        graphics.drawString(Main.moduleNames[Main.decks[deckindex][jj][ii]], i, j);
                    }catch(Exception e){}
                }
            }
        //drawing borders
        graphics.setColor(Color.BLACK);
        graphics.setStroke(new BasicStroke(3F));

        int tt = Main.noOfRX[deckindex];        
        for(int j=0; j<tt; j++)
        {
            int _stxx =stx + Main.rectX[deckindex][j].stX*pxl;
            int _styy = sty + Main.rectX[deckindex][j].stY*pxl;
            int _totl = Main.rectX[deckindex][j].totalLen*pxl;
            int _mlw = Main.rectX[deckindex][j].modLw*pxl;
            int _nmod = Main.rectX[deckindex][j].noOfMod;

            graphics.drawRect(_styy,_stxx, _mlw, _totl);

            int _jump = _totl/_nmod; //width
            int y = _stxx + _jump;
            int _nn = _styy +_mlw;
            for(int k=1; k<_nmod; k++)
            {
                graphics.drawLine(_styy, y, _nn, y);
                y += _jump;
            }
        }
        int nn = Main.noOfRY[deckindex];
        for(int j=0; j<nn; j++)
        {
            int stxx = stx + Main.rectY[deckindex][j].stX*pxl;
            int styy = sty + Main.rectY[deckindex][j].stY*pxl;
            int totl = Main.rectY[deckindex][j].totalLen*pxl;
            int mlw =  Main.rectY[deckindex][j].modLw*pxl;
            int  nmod = Main.rectY[deckindex][j].noOfMod;

            if (nmod == 0) continue;

            int jump = totl/nmod; //length
            graphics.drawRect(styy,stxx, totl, mlw);

            int x = styy+ jump;
            int mm = Main.rectY[deckindex][j].noOfMod;
            int ll = stxx + mlw;
            for(int k=1; k<mm; k++)
            {
                graphics.drawLine(x, stxx, x, ll);
                x += jump;
            }
        }
    }
}